"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RxJSUtil = void 0;
const rxjs_1 = require("rxjs");
const operators_1 = require("rxjs/operators");
class RxJSUtil {
    static timeout(each, message) {
        return (source) => {
            return source.pipe((0, operators_1.timeout)(each), (0, operators_1.catchError)(error => (0, rxjs_1.of)(error)), (0, operators_1.map)(value => {
                if (value instanceof Error) {
                    if (value.message === 'Timeout has occurred') {
                        throw new Error(message);
                    }
                    throw value;
                }
                return value;
            }));
        };
    }
}
exports.RxJSUtil = RxJSUtil;
