"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EventStore = void 0;
const rxjs_1 = require("rxjs");
class EventStore {
    constructor() {
        this._events = [];
        this._events$ = new rxjs_1.ReplaySubject(100);
        this._events$.subscribe();
    }
    list(by) {
        let result = this._events;
        if (by?.types && by.types.length > 0) {
            result = result.filter(item => by.types.includes(item.type));
        }
        return result;
    }
    listen() {
        return this._events$;
    }
    add(event) {
        const id = this._events.length + 1;
        this._events.push({ id, ...event });
        this._events$.next({ id, ...event });
        return id;
    }
}
exports.EventStore = EventStore;
